﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Bullet
    {
        public Texture2D Sprite;
        public Vector2 Position;
        public Vector2 Velocity;
        public Rectangle BulletRect;
        const float BULLETSPEED = 10f;
        public bool removeFromWorld = false;

        public Bullet(Texture2D sprite, Vector2 position)
        {
            this.Sprite = sprite;
            this.Position = position;
            this.Velocity = new Vector2(BULLETSPEED, 0);
            BulletRect = new Rectangle((int)Math.Round(this.Position.X), (int)Math.Round(this.Position.Y), this.Sprite.Width, this.Sprite.Height);
        }

        public void Update()
        {
            if (this.Position.X > 1024 + 5)
                this.removeFromWorld = true;
            this.Position.X += this.Velocity.X;
            this.BulletRect.X = (int)Math.Round(this.Position.X);
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(this.Sprite, this.Position, new Color(224, 23, 101));
        }
    }
}
