﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Cloud
    {
        public Vector2 Position;
        public Texture2D Sprite;
        public Vector2 Velocity;
        public float Speed;

        public Cloud(Texture2D sprite, Vector2 position, float speed)
        {
            this.Position = position;
            this.Sprite = sprite;
            this.Speed = -speed;
            this.Velocity = new Vector2(speed, 0);
        }

        public void Update(float gameSpeed) 
        {
            this.Velocity.X = this.Speed * gameSpeed;

            if (this.Position.X < 0 - this.Sprite.Width)
                this.Position.X = 1024 + this.Sprite.Width;

            this.Position.X += this.Velocity.X;
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(this.Sprite, this.Position, Color.White);
        }
    }
}
