﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Coin
    {
        public Vector2 Position;
        public Vector2 Velocity;
        public Texture2D Sprite;
        public Rectangle SourceRect;
        public Rectangle DestRect;
        const int FRAMEWIDTH = 40;
        int Offset;
        public bool removeFromWorld = false;

        public Coin(Texture2D sprite, Vector2 position, float randPosition)
        {
            this.Sprite = sprite;
            this.Position = position;
            this.Position.Y = this.Position.Y / randPosition;
            this.Velocity = new Vector2(5, 2);
            this.Offset = 0;
            this.SourceRect = new Rectangle(this.Offset * FRAMEWIDTH, 0, FRAMEWIDTH, this.Sprite.Height);
            this.DestRect = new Rectangle((int)Math.Round(this.Position.X), (int)Math.Round(this.Position.Y), FRAMEWIDTH, this.Sprite.Height);
        }

        public void Update(float gameSpeed) 
        {
            this.Offset++;
            if (this.Offset > 4 * 4) this.Offset = 0;
            this.SourceRect.X = this.Offset / 4 * FRAMEWIDTH;

            this.Velocity.X = gameSpeed;
            if (this.Position.Y > 550 || this.Position.Y < 100)
                this.Velocity.Y = -this.Velocity.Y;

            this.Position.X -= this.Velocity.X;
            this.Position.Y += this.Velocity.Y;

            this.DestRect.X = (int)Math.Round(this.Position.X);
            this.DestRect.Y = (int)Math.Round(this.Position.Y);

            if (this.Position.X < -128)
                this.removeFromWorld = true;
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(this.Sprite, this.DestRect, this.SourceRect, Color.White);
        }
    }
}
