﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Enemy
    {
        public Texture2D Sprite;
        public Vector2 Position;
        public Vector2 Velocity;
        public Rectangle EnemyRect;
        public bool removeFromWorld = false;
        public int HP = 6;
        public TimeSpan JumpRate = TimeSpan.FromSeconds(0.7f);
        public TimeSpan lastJump = TimeSpan.Zero;
        public bool Jump = false;
        TimeSpan CreationTime;
        public int HitTimer = 0;
        Color color;

        public Enemy(Texture2D sprite, Vector2 position, GameTime gameTime)
        {
            this.Sprite = sprite;
            this.Position = position;
            this.EnemyRect = new Rectangle((int)Math.Round(this.Position.X), (int)Math.Round(this.Position.Y), this.Sprite.Width, this.Sprite.Height);
            this.Velocity = new Vector2(-1, 0);
            this.CreationTime = gameTime.TotalGameTime;
            this.color = Color.White;
            this.HitTimer = 0;
        }
        public void Update(GameTime gameTime, float speed)
        {
            if (this.HitTimer != 0)
            {
                this.color = Color.Red;
                this.HitTimer--;
            }
            else
                this.color = Color.White;

            if (gameTime.TotalGameTime - lastJump - this.CreationTime > JumpRate)
            {
                lastJump = gameTime.TotalGameTime;
                this.Jump = true;
            }

            // Jump
            if (this.Jump)
            {
                this.Velocity.Y = -20;
                this.Jump = false;
            }

            // Gravity
            if (!this.Jump)  this.Velocity.Y += 0.7f;

            if (this.Position.Y + this.Velocity.Y > 500)
            {
                this.Velocity.Y = 0;
            }

            this.Velocity.X = -speed;
            this.Position.X += this.Velocity.X;
            this.Position.Y += this.Velocity.Y;

            if (this.Position.X < -128 || this.HP < 0)
                this.removeFromWorld = true;

            // For collisions
            this.EnemyRect.X = (int)Math.Round(this.Position.X);
            this.EnemyRect.Y = (int)Math.Round(this.Position.Y);
        }
        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(this.Sprite, this.Position, this.color);
        }
    }
}
