﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Ground
    {
        public Texture2D Sprite;
        public Vector2 Position;
        public Vector2 Velocity;
        public int SpriteSheetOffset;
        const int FRAMEWIDTH = 128;
        public Rectangle SourceRect;
        public Rectangle DestRect;
        public bool RemoveFromWorld = false;

        public Ground(Texture2D sprite, Vector2 position, int offset)
        {
            this.Sprite = sprite;
            this.Position = position;
            this.SpriteSheetOffset = offset;
            this.Velocity = new Vector2(-1, 0);
            this.SourceRect = new Rectangle(offset * FRAMEWIDTH, 0, FRAMEWIDTH, 200);
            this.DestRect = new Rectangle((int)Math.Round(this.Position.X), (int)Math.Round(this.Position.Y), FRAMEWIDTH+50, 200);
        }

        public void Update(float speed) 
        {
            this.Velocity.X = -speed;
            this.Position.X += this.Velocity.X;
            this.DestRect.X = (int)Math.Round(this.Position.X);
            if (this.Position.X < -127)
                this.RemoveFromWorld = true;
        }
        public void Draw(SpriteBatch spriteBatch) 
        {
            spriteBatch.Draw(this.Sprite, this.DestRect, this.SourceRect, Color.White); 
        }

    }
}
