﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Particle
    {
        public Texture2D Sprite;
        public Vector2 Position;
        public Vector2 Velocity;
        public Rectangle ParticleRect;
        public bool removeFromWorld = false;
        int TTL = 100;
        int Size;
        Color color;

        public Particle(Texture2D sprite, Vector2 originPosition, float velx, float vely, int size, Color color)
        {
            this.Sprite = sprite;
            this.Position = originPosition;
            this.Size = size;
            float randomVelocityX = velx;
            float randomVelocityY = vely;
            this.color = color;

            this.Velocity = new Vector2(randomVelocityX, randomVelocityY);

            this.ParticleRect = new Rectangle((int)Math.Round(this.Position.X), (int)Math.Round(this.Position.Y), this.Size, this.Size);
        }

        public void Update() 
        {
            this.TTL--;
            this.Size--;
            if (this.Size < 1 )
                this.Size = 1;
            this.ParticleRect.X += (int)Math.Round(this.Velocity.X);
            this.ParticleRect.Y += (int)Math.Round(this.Velocity.Y);
            this.ParticleRect.Width = this.Size;
            this.ParticleRect.Height = this.Size;

            if (this.TTL < 0)
                this.removeFromWorld = true;
           
        }
        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(this.Sprite, this.ParticleRect, this.color);
        }

    }
}
