﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace PKJ
{
    class Platform
    {
        Vector2 Position;
        Vector2 Velocity;
        Texture2D Sprite;
        public Rectangle PlatformRectangle;

        public Platform(Texture2D sprite, Vector2 position)
        {
            this.Sprite = sprite;
            this.Position = position;
            this.Velocity = new Vector2(-1, 0);
            PlatformRectangle = new Rectangle((int)Math.Round(this.Position.X), (int)Math.Round(this.Position.Y), this.Sprite.Width, this.Sprite.Height);
        }

        public void Update(float gameSpeed)
        {
            this.Velocity.X = -gameSpeed;
            this.Position.X += this.Velocity.X;
            PlatformRectangle.X = (int)Math.Round(this.Position.X);
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(this.Sprite, this.Position, Color.White);
        }
    }
}
